_TITLE "Boggle Word Search"
DEFINT A-Z
SCREEN 0
WIDTH 80
CONST Num$ = "0123456789", Cuckoo$ = "T120L16MLO3BF#"
VIEW PRINT
CLS
_FULLSCREEN _OFF
LOCATE 1, 31
COLOR 9
PRINT "BOGGLE WORD SEARCH";
LOCATE 6, 20
COLOR 2
PRINT "NOTE: When Running, Hit ";
COLOR 14
PRINT "<Esc>";
COLOR 2
PRINT " to Restart";
LOCATE 9, 5
COLOR 2
PRINT "Hit the ";
COLOR 14
PRINT "<Spacebar>";
COLOR 2
PRINT " to Start The Timer, then to Pause/Resume The Timer";
'
HowBig:
'
VIEW PRINT 12 TO 24
COLOR 14
CLS
LOCATE 24, 30
COLOR 7
PRINT "Hit ";
COLOR 23
PRINT "<Enter>";
COLOR 7
PRINT " to Quit";
LOCATE 12, 27
COLOR 2
PRINT "Grid Side (  4 &  20): ";
COLOR 14
LINE INPUT ; Square$
Square$ = LTRIM$(RTRIM$(Square$))
IF Square$ = "" THEN
    SYSTEM
ELSEIF LEFT$(Square$, 1) = "0" THEN
    GOTO HowBig
END IF
FOR X = 1 TO LEN(Square$)
    IF INSTR(Num$, MID$(Square$, X, 1)) = 0 THEN
        GOTO HowBig
    END IF
NEXT X
Square = VAL(Square$)
IF Square < 4 OR Square > 20 THEN
    GOTO HowBig
END IF
'
HowLong:
'
VIEW PRINT 15 TO 24
COLOR 14
CLS
LOCATE 24, 27
COLOR 7
PRINT "Hit ";
COLOR 23
PRINT "<Enter>";
COLOR 7
PRINT " to Go Back Up";
LOCATE 15, 20
COLOR 2
PRINT "Timer Length in Minutes (  3 &  30): ";
COLOR 14
LINE INPUT ; Length$
Length$ = LTRIM$(RTRIM$(Length$))
IF Length$ = "" THEN
    GOTO HowBig
ELSEIF LEFT$(Length$, 1) = "0" THEN
    GOTO HowLong
END IF
FOR X = 1 TO LEN(Length$)
    IF INSTR(Num$, MID$(Length$, X, 1)) = 0 THEN
        GOTO HowLong
    END IF
NEXT X
Length = VAL(Length$)
IF Length < 3 OR Length > 30 THEN
    GOTO HowLong
END IF
MinCol = INT((40 - Square) \ 2)
MaxCol = MinCol + Square - 1
MinRow = INT((25 - Square) \ 2) + 3
MaxRow = MinRow + Square - 1
COLOR 7
RANDOMIZE USING TIMER
SCREEN 0
WIDTH 40
_FULLSCREEN _STRETCH
CLS
'
FillSquare:
'
_DELAY .001
Character = INT(26 * RND + 65)
TheColumn = INT((MaxCol - MinCol + 1) * RND + MinCol)
TheRow = INT((MaxRow - MinRow + 1) * RND + MinRow)
LOCATE TheRow, TheColumn
PRINT CHR$(Character);
DO
    An$ = INKEY$
    IF LEN(An$) THEN
        IF An$ = CHR$(27) THEN
            RUN
        ELSEIF An$ = CHR$(32) THEN
            PLAY Cuckoo$
            LOCATE 1, 7
            COLOR 2
            PRINT "Timer is set for";
            COLOR 14
            PRINT Length;
            COLOR 2
            PRINT "Minutes";
            GOTO WhatTime
        END IF
    ELSE
        EXIT DO
    END IF
LOOP
GOTO FillSquare
'
WhatTime:
'
_DELAY 1
Seconds = Seconds + 1
IF Seconds / 60 = INT(Seconds / 60) AND Seconds <> 0 THEN
    Minutes = Minutes + (Seconds / 60)
    Seconds = 0
END IF
COLOR 14
IF Minutes = 0 THEN
    LOCATE 2, 15
    PRINT Seconds;
    COLOR 2
    IF Seconds < 2 THEN
        PRINT "Second";
    ELSE
        PRINT "Seconds";
    END IF
ELSE
    LOCATE 2, 10
    PRINT Minutes;
    COLOR 2
    IF Minutes < 2 THEN
        PRINT "Minute";
    ELSE
        PRINT "Minutes";
    END IF
    PRINT ",";
    COLOR 14
    PRINT Seconds;
    COLOR 2
    PRINT "Seconds";
    IF Seconds < 10 THEN
        PRINT SPC(2);
    END IF
END IF
IF Minutes = Length THEN
    LOCATE 3, 18
    COLOR 31
    PRINT "STOP";
    PLAY Cuckoo$
    WHILE INKEY$ = ""
        _LIMIT 25
    WEND
    RUN
END IF
DO
    An$ = INKEY$
    IF LEN(An$) THEN
        IF An$ = CHR$(27) THEN
            RUN
        ELSEIF An$ = CHR$(32) THEN
            LOCATE 3, 17
            COLOR 31
            PRINT "PAUSED";
            PLAY Cuckoo$
            WHILE INKEY$ = ""
                _LIMIT 25
            WEND
            PLAY Cuckoo$
            LOCATE 3, 17
            PRINT SPC(6);
            GOTO WhatTime
        END IF
    ELSE
        EXIT DO
    END IF
LOOP
GOTO WhatTime

